package dev.jansel.aglaea.utils

import com.github.philippheuer.credentialmanager.domain.OAuth2Credential
import com.github.twitch4j.TwitchClientBuilder
import com.github.twitch4j.chat.events.channel.ChannelMessageEvent
import dev.jansel.aglaea.logger
import dev.jansel.aglaea.twitchClient
import dev.kordex.core.koin.KordExKoinComponent

class Twitch : KordExKoinComponent {
	suspend fun init() {
		twitchClient = TwitchClientBuilder.builder()
			.withEnableHelix(true)
			.withEnableChat(true)
			.withEnableGraphQL(true)
			.withChatAccount(OAuth2Credential("twitch", twitchToken))
			.withClientId(twitchcid)
			.withClientSecret(twitchcs)
			.build()

		twitchClient!!.chat.joinChannel(getTwitchNameById("120275141"))

		twitchClient!!.eventManager.onEvent(ChannelMessageEvent::class.java) { event ->
			if (event.customRewardId.isPresent && event.customRewardId.get() == "38157e62-de35-4a21-8200-447b55d7577e") {
				logger.info { "Channel points redeemed: ${event.customRewardId.get()}" }
			}
		}
	}
}
